wall = 4.0;
hole = 17.0;
width = hole + 2*wall;
height = 30.0-0.75;
$fs=0.1;
$fa=0.5;

module hole()
{
#    translate([-width/2+1, 0, 3.7+wall]) rotate([0, 90, 0]) hull() {
        translate([-(3-1.0), 0, 0]) cylinder(r=1.7, h=wall*4, center=true);
        translate([+(3-1.0), 0, 0]) cylinder(r=1.7, h=wall*4, center=true);
    }
}

module outside() {
    difference() {
        translate([0, 0, height/2])
            cylinder(r = width/2, h=height, center = true);
        translate([0, 0, height/2+wall])
            cylinder(r = width/2-wall, h=height, center = true);
        cylinder(r = 1.65, h = wall*3, center=true);
    }
}

module inside() {
    difference() {
        cylinder(r = hole/2+1, h = 6);
        translate([0, 0, -0.5]) hull() {
            cylinder(r = hole/2, h = 0.5);
            translate([0, 0, hole/3]) cylinder(r = hole/3, h = 0.5);
        }
        cylinder(r = hole/2-2.5, h=height/3);
    }
}

difference() {
    union() {
        outside();
        translate([0, 0, 9]) inside();
    }
    hole();
}